const uuidv4 = require('uuid/v4');
const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");
class BusinesschanceService extends ServiceBase {
  constructor() {
    super("dbneed", ServiceBase.getDaoName(BusinesschanceService));
    // this.cacheManager = system.getObject("db.cacheManager");
    // this.shopSve = system.getObject("service.shopSve");
    // this.servicesitemSve = system.getObject("service.servicesitemSve");
    // this.pconfigSve = system.getObject("service.pconfigSve");
    // this.channelSve = system.getObject("service.channelSve");
    this.connectionigirl = system.getObject("db.common.connection").getConigirl();
  }
  async findAllChances(obj) {
    return this.dao.model.findAll({ where: obj, attributes: ["id", "chanceStatus", "chanceStatusName", "publisherName", "publisherMobile", "created_at", "channelCode", "chanceType", "chanceTypeName"], raw: true, order: [["created_at", "desc"]] });
  }
  async findchance(obj) {
    return this.dao.model.findOne({ where: obj });
  }
  async findAllChancesByPublisherids(ids) {
    var sql = "SELECT * FROM	h_business_chance	WHERE	user_id = " + userId;
    console.log(sql);
    var payUserIds = await this.dao.customQuery(sql);
    return payUserIds;
  }

  async subNeed(obj){
    var user = obj.user;
    var app = obj.app;
    if(!user){
      return system.getResultFail(-100, "未知用户");
    }
    if(!app){
      return system.getResultFail(-101, "未知渠道");
    }
    var needNo=await this.getBusUid("ni");
    var needObj={
      app_id           :app.id,
      needNo           :needNo,
      needDesc         :obj.needDesc,
      needUserMoblie   :obj.needUserMoblie,
      notes            :obj.notes,
      channelUserName  :user.channelUserName,
      auditStatus      :"00",
      createuser_id    :user.id,
      itemCode:obj.itemCode                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
    };
    var need = await this.dao.create(needObj);
    return system.getResultSuccess(need);
  }

  async zc2channel() {
    try {
      var lastsql = "select id from h_business_chance order by id desc";
      var maxid = await this.dao.customQuery(lastsql);
      var id = 0
      if (maxid && maxid.length > 0) {
        id = maxid[0].id
      }
      var sql = "select * from h_business_chance where id>" + id;
      var chanceinfos = await this.connectionigirl.query(sql);
      if (chanceinfos) {
        console.log(chanceinfos[0]);
        console.log(chanceinfos[0].length);
        var newchanceinfos = []
        for (let i = 0; i < chanceinfos[0].length; i++) {
          const chanceinfo = chanceinfos[0][i];
          newchanceinfos.push(chanceinfo);
        }
        console.log(newchanceinfos);
        var result = await this.dao.bulkCreate(newchanceinfos);
        return { status: 0 };;
      }
    } catch (error) {
      return { status: -1, msg: error };
    }

  }


}
module.exports = BusinesschanceService;

